package com.loafle.overflow.service.central.infra;

import java.util.List;

import com.loafle.overflow.core.annotation.WebappAPI;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.core.model.PageParams;
import com.loafle.overflow.model.discovery.Host;
import com.loafle.overflow.model.discovery.Service;
import com.loafle.overflow.model.infra.Infra;
import com.loafle.overflow.model.infra.InfraHost;

import org.springframework.data.domain.Page;

/**
 * Created by insanity on 17. 6. 28.
 */
public interface InfraService {

  @WebappAPI
  Infra regist(Infra infra) throws OverflowException;

  @WebappAPI
  Infra read(Long id) throws OverflowException;

  @WebappAPI
  Page<Infra> readAllByProbeID(Long probeID, PageParams pageParams) throws OverflowException;

  @WebappAPI
  Page<Infra> readAllByDomainID(Long domainID, PageParams pageParams) throws OverflowException;

  @WebappAPI
  InfraHost regist(Long probeID, Host host) throws OverflowException;

  @WebappAPI
  InfraService regist(Long probeID, Service service) throws OverflowException;
}
