package com.loafle.overflow.service.central.member;

import com.loafle.overflow.core.annotation.WebappAPI;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.member.Member;
import com.loafle.overflow.model.member.MemberTotp;
import java.util.Map;

/**
 * Created by geek on 18. 3. 8.
 */
public interface MemberTotpService {
    @WebappAPI
    void regist(Member member, String secretCode, String code) throws OverflowException;

    @WebappAPI
    MemberTotp modify(MemberTotp totp) throws OverflowException;

    @WebappAPI
    void remove(Long id) throws OverflowException;

    @WebappAPI
    MemberTotp read(Long id) throws OverflowException;

    @WebappAPI
    boolean checkCodeForMember(String email, String code) throws OverflowException;

    @WebappAPI
    boolean checkCode(String secretCode, String code) throws OverflowException;

    @WebappAPI
    Map<String, String> createTotp(Member member) throws OverflowException;
}
